function update_Trigger_Callback(obj, ~, handles )
%UPDATE_TRIGGER_CALLBACK Summary of this function goes here
%   Detailed explanation goes here
% stop(watchdog);
% start(watchdog);
ValuesPerChannel = obj.ValuesReceived/2;
x_offset = ValuesPerChannel;
x_vec = handles.PLFIFOGet.ReadoutSizeGetParam/2;
time = (0:handles.PLFIFOGet.FIFOPushSampleTime:(handles.PLFIFOGet.FIFOPushSampleTime*(x_vec-1)))';
data = getappdata(handles.GUI_Storage,'TriggerData');
rawdata = uint32(fread(obj,handles.PLFIFOGet.ReadoutSizeGetParam,'uint32'));

%data_idx_plot = 1:handles.API.PLFIFOBuf.PLFIFOSize;
data_idx_data = (x_offset+1):(x_offset+x_vec);

% TODO: accelerate this for loop (mex file)
for idx = 1:2
    % y-Values
    data(data_idx_data,idx*2) = reinterpretcast(rawdata(handles.PLFIFOGet.t(idx,:)),handles.PLFIFOGet.T(idx));
    % x-Values
    data(data_idx_data,idx*2-1) = time + (handles.PLFIFOGet.FIFOPushSampleTime * ValuesPerChannel);
    % plot Version1:
    %set(handles.hFIFO(idx),'XData',data(:,idx*2-1),'YData',data(:,idx*2));
    % plot Version2:
    addpoints(handles.hFIFO(idx),data(data_idx_data,idx*2-1),data(data_idx_data,idx*2));
    %set(handles.hFIFO(idx),'XData',data(data_idx_plot,idx*2-1),'YData',data(data_idx_plot,idx*2));
    %handles.(['TriggerData',num2str(idx)]).XLim = [max([(max(data(:,idx*2-1))-xAxisLim);0]), max([data(:,idx*2-1);xAxisLim])];
end
drawnow;
% if end reached, store triggered data and close udp object
if x_offset == (handles.API.PLFIFOBuf.PLFIFOSize - x_vec)
    % save to file before new trigger is fired (.mat and bit file)
    % .mat file is more comfortable to readback and smaller storage size, but takes 5 times
    % more time
    % to read back mat file in folder: listing = dir(fullfile('TriggerData','*.mat'))
    t = datestr(now,'yy_mm_dd_HHMMss'); % generate time stamp
    save(fullfile(handles.TriggerStorePath,sprintf('%s_TriggerSignal.mat',t)),'data');
    %close udp object
    [handles, state] = udp_Trigger(handles, 0);
    handles.TriggerReadout.BackgroundColor = [0,1,0];
    if state < 0
        error('Could not close udp object Trigger.');
    end
end
setappdata(handles.GUI_Storage,'TriggerData',data);
end

