%% load Main Framework in the background
open_system('../models/framework_main.slx','loadonly')

%% set all sample and simulation times to the correct value for PL work
hws=get_param(bdroot,'modelworkspace');
freq=hws.getVariable('pl_clock_freq');
hws.assignin('pl_axi_ts',1/freq.Value);
hws.assignin('pl_axi_ts_dummy',1/freq.Value);

set_param('framework_main','SolverMode','Auto');
set_param('framework_main','FixedStep','Auto');
set_param('framework_main','SimulationMode','Normal');

%% open user canvases from Main Framework
open_system('framework_main','window')
open_system('framework_main/pl_framework/Init State/User Init State','tab')
open_system('framework_main/pl_framework/Stop State/User Stop State','tab')
open_system('framework_main/pl_framework/Run State/User Run State','tab')
open_system('framework_main/pl_framework/Failsafe State/User Failsafe State','tab')
open_system('framework_main/pl_framework/Monitoring/User Monitoring','tab')