%% Remove ersistent deployment of generated code and bit file
% check if zynq object exist in workspace
if ~exist('z','var')
    z = zynq();
else
    if ~isa(z,'zynq.util.LinuxServices')
    z = zynq();
    end
end
% variables
exname = 'system.elf';
bitname = 'system.bit';

% remove files from SD card
if strcmp(z.checkConnection,['Connection successful' 10]);
    z.execute(['rm /mnt/Model/', exname]);
    z.execute(['rm /mnt/Model/', bitname]);
    % reboot system to program fpga and run program
    z.execute('reboot');
else
    error('Could not establish connection.')
end
