%% Temporary Deployment of Generated Code
% check if zynq object exist in workspace
if ~exist('z','var')
    z = zynq();
else
    if ~isa(z,'zynq.util.LinuxServices')
    z = zynq();
    end
end

% prepare
bitsearchpath = '../work/hdl_prj/vivado_ip_prj/vivado_prj.runs/impl_1/';
[bitfile, bitpath, ~] = uigetfile([bitsearchpath,'*.bit'],'Select the bitfile to be deployed...');
bitname = 'system.bit';
model = 'gm_framework_main_interface';
path = '../work/';

% deploy generated code to tmp
if ~ischar(bitfile)
    error('No bit file chosen.')
else
    if strcmp(z.checkConnection,['Connection successful' 10]);
        z.execute('rm -rf /tmp && mkdir /tmp');
        z.putFile([bitpath, bitfile],['/tmp/', bitname]);
        z.execute('/usr/bin/zynqfpgaprog /tmp/system.bit');
        z.putFile([path, model],'/tmp/');
        z.execute(['chmod +x /tmp/', model]);
        z.stop(['/tmp/' model]);
        z.run(['/tmp/' model]);
        fprintf('The model %s is running on the target.\n',model);
    else
        error('Could not establish connection.')
    end
end