function [ uint32Setdata ] = Setdata2uint32( Setdata )
%SETDATA2UINT32 Summary of this function goes here
%   Detailed explanation goes here
T_uint32 = numerictype(0,32,0);
nrElement = size(Setdata,1);
uint32Setdata = zeros(1,nrElement);
for idx = 1:nrElement
    SetValue = Setdata{idx,3};
    datatype = Setdata{idx,6};
    if strfind(datatype,'boolean')
        uint32Setdata(1,idx) = uint32(SetValue);
    else
        datatype = numerictype(datatype);   % create numerictype object
        datatype.WordLength = 32;           % expand wordlength to 32
        Setvalue = fi(SetValue,datatype);
        uint32Setdata(1,idx) = reinterpretcast(Setvalue, T_uint32);
    end
end
end

