function update_TriggerSetValues_Callback( obj, ~, handles )
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here
% disp('now')
% tic
nrElem = numel(handles.API.PLFIFOBuf.SetParamName);
% read rawdata and flush inputbuffer
rawdata = fread(obj, nrElem + 1, 'uint32');
% TODO: remove flushinput(obj) bad for performance
%flushinput(obj);
% load current GetData from table
data = get(handles.TriggerValuesTable,'Data');
T_uint32 = numerictype(0,32,0);
transformedData = zeros(nrElem,1);
for idx = 1:nrElem
    GetValue = rawdata(idx);
    Get_uint32Value = fi(GetValue,T_uint32);
    % read out original datatype
    datatype = data{idx,6};
    datatype = numerictype(datatype);
    % change wordlength to 32
    datatype.WordLength = 32;
    % transform uint32 back to original datatype
    backTransformedValue = reinterpretcast(Get_uint32Value,datatype);
    transformedData(idx,1) = str2double(backTransformedValue.Value);
end
% rearange data to write in table
data(:,2) = mat2cell(transformedData,ones(nrElem,1));
% write new GetData in table
set(handles.TriggerValuesTable,'Data',data);

% Trigger readback
Trigger = rawdata(3);
if Trigger == 0
    set(handles.CurrentTriggerValue, 'String', 'Step 1-2')
    set(handles.CurrentTriggerValue, 'Value', 0);
elseif Trigger == 1
    set(handles.CurrentTriggerValue, 'String', 'Step 2-1');
    set(handles.CurrentTriggerValue, 'Value', 1);
else
    error('Current Trigger Value invalid!');
end
% toc

end

