%% startup HDL workflow advisor
h=msgbox({'Consider that this might take a while. Please stay patient until the HDL Workflow Advisor is open... Go grab a coffee!'});
cd '../work'
open_system('../models/framework_main.slx','loadonly');

%% set all sample and simulation times to the correct value for PL code generation
hws=get_param(bdroot,'modelworkspace');
freq=hws.getVariable('pl_axi_freq');
hws.assignin('pl_axi_ts',1/freq.Value);
hws.assignin('pl_axi_ts_dummy',1/freq.Value);

set_param('framework_main','SolverMode','SingleTasking');
set_param('framework_main','FixedStep','Auto');

%% start workflow advisor
hdladvisor('framework_main/pl_framework')
